package edu.travel.commodity.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import edu.travel.commodity.entity.ShopProduct;
import edu.travel.remote.dto.*;
import edu.travel.remote.vo.ShopProductVo;
import edu.travel.rpc.RPCBaseResponse;

import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface ShopProductService extends IService<ShopProduct> {

    Page<ShopProductVo> getHotProduct(GetProductByTypeDto param);

    Page<ShopProductVo> searchProduct(SearchProductDto param) throws IOException;

    void insertProduct(InsertProductDto params);

    RPCBaseResponse<Void> saveProduct(InsertProductDto params);
    
    /**
     * 批量规格输入，生成组合
     * @param specList 规格列表，最多输入3组规格
     * @return 组合后的规格名与规格值列表，每个组合包含以索引(0,1,2...)为键的规格对象(含specName和specValueName)和默认库存"inventory"为"0"
     */
    RPCBaseResponse<List<Map<String, Object>>> batchSpecAndValueGenerate(List<InsertProductSpecDto> specList);

    /**
     * 生成更结构化的规格组合
     * @param specList 规格列表
     * @return 结构化的规格组合结果，每个组合包含以索引(0,1,2...)为键的规格对象(含specName和specValueName)和默认库存"inventory"为"0"
     */
    RPCBaseResponse<List<Map<String, Object>>> generateStructuredSpecCombinations(List<InsertProductSpecDto> specList);
}
